/*
    Copyright (C) 2008-2019, Millistream Market Data <support@millistream.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MDFCRYPT_H
# define MDFCRYPT_H 1

#define MIN_DH_LENGTH 256
#define MAX_DH_LENGTH (MIN_DH_LENGTH * 4)
#define MAX_ENCRYPTED_MESSAGES_PER_KEY 4294967295

#if OPENSSL_VERSION_NUMBER < 0x10100000L
# define EVP_MD_CTX_free(a) EVP_MD_CTX_destroy(a)
#endif

enum enc_or_dec {
	DECRYPT,
	ENCRYPT
};

RSA *mdf_int_load_rsapublickey ();
void mdf_int_set_keys (struct crypto *crypto, const enum enc_or_dec enc_or_dec, unsigned char * restrict nonce, int nonce_len);
void mdf_int_handle_server_rekey (struct crypto *crypto, uint8_t *data, const size_t tlen);

#endif

